//+------------------------------------------------------------------
//|
//|
//|
//+------------------------------------------------------------------
#property  copyright ""
#property  link      ""
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Silver
#property  indicator_color2  Red
#property  indicator_width1  2

//
//
//
//
//

extern string symbol    = "EURGBP";
extern int    FastEMA   = 12;
extern int    SlowEMA   = 26;
extern int    SignalSMA =  9;

double MacdBuffer[];
double SignalBuffer[];
bool   returnBars;
string indicatorFileName;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   IndicatorDigits(Digits+1);
   SetIndexBuffer(0,MacdBuffer);   SetIndexLabel(0,"MACD");   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,SignalBuffer); SetIndexLabel(1,"Signal");
   
      //
      //
      //
      //
      //
      
      returnBars = (symbol=="returnBars"); if (returnBars) return(0);
      indicatorFileName = WindowExpertName();
      
   IndicatorShortName("MACD("+FastEMA+","+SlowEMA+","+SignalSMA+") symbol="+symbol);
   return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { MacdBuffer[0] = MathMin(limit+1,Bars-1); return(0); }
           if (symbol!=Symbol()) limit= MathMin(Bars-1,MathMax(limit,iCustom(symbol,0,indicatorFileName,"returnBars",0,0)));

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      int y = iBarShift(symbol,0,Time[i]);
         MacdBuffer[i] = iMA(symbol,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,y)-iMA(symbol,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,y);
   }         
   for(i=limit; i>=0; i--) SignalBuffer[i] = iMAOnArray(MacdBuffer,0,SignalSMA,0,MODE_SMA,i);
   return(0);
}